package client

import (
	apb "code.fbi.h-da.de/danet/gosdn/api/go/gosdn/app"
	"google.golang.org/grpc"
)

var appClientConnection *grpc.ClientConn

// AppClient returns a client for the gRPC App service. It takes
// the address of the gRPC endpoint and optional grpc.DialOption
// as argument.
func AppClient(addr string, opts ...grpc.DialOption) (apb.AppServiceClient, error) {
	var err error

	if appClientConnection == nil {
		appClientConnection, err = grpc.NewClient(addr, opts...)
		if err != nil {
			return nil, err
		}
	}
	return apb.NewAppServiceClient(appClientConnection), nil
}
