package client

import (
	subpb "code.fbi.h-da.de/danet/gosdn/api/go/gosdn/subscriptionmanagement"
	"google.golang.org/grpc"
)

var subManagementClientConnection *grpc.ClientConn

// SubManagementClient returns a client for the gRPC SubscriptionManagement service. It takes
// the address of the gRPC endpoint and optional grpc.DialOption
// as argument.
func SubManagementClient(addr string, opts ...grpc.DialOption) (subpb.SubscriptionManagementServiceClient, error) {
	var err error

	if subManagementClientConnection == nil {
		subManagementClientConnection, err = grpc.NewClient(addr, opts...)
		if err != nil {
			return nil, err
		}
	}

	return subpb.NewSubscriptionManagementServiceClient(subManagementClientConnection), nil
}
