import {
    NetworkelementFlattenedManagedNetworkElement,
    NetworkelementManagedNetworkElement,
    PluginRegistryPlugin
} from '@api/api'
import { createSlice, PayloadAction } from '@reduxjs/toolkit'
import '../routines/index'

export type Device = NetworkelementFlattenedManagedNetworkElement

interface SelectedObject {
    device: Device
    mne: NetworkelementManagedNetworkElement | null
    json: JSON | null
}

export interface PluginSliceState {
    plugins: Array<PluginRegistryPlugin>
}

const initialState: PluginSliceState = {
    plugins: [],
}

interface SetSelectedDeviceType {
    device: Device | null,
    options?: {
        bypassCheck: boolean
    }
}

const pluginSlice = createSlice({
    name: 'plugins',
    initialState,
    reducers: {
        setPlugins: (state, action: PayloadAction<PluginRegistryPlugin[] | undefined>) => {
            state.plugins = action.payload || []
        },
    },
})

export const { setPlugins } =
    pluginSlice.actions

export default pluginSlice.reducer
export const pluginReducerPath = pluginSlice.reducerPath
